/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */

/*
 * Copyright (C) 1997 by the University of Southern California
 * $Id: classifier-mpath.cc,v 1.10 2005/08/25 18:58:01 johnh Exp $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * The copyright of this module includes the following
 * linking-with-specific-other-licenses addition:
 *
 * In addition, as a special exception, the copyright holders of
 * this module give you permission to combine (via static or
 * dynamic linking) this module with free software programs or
 * libraries that are released under the GNU LGPL and with code
 * included in the standard release of ns-2 under the Apache 2.0
 * license or under otherwise-compatible licenses with advertising
 * requirements (or modified versions of such code, with unchanged
 * license).  You may copy and distribute such a system following the
 * terms of the GNU GPL for this module and the licenses of the
 * other code concerned, provided that you include the source code of
 * that other code when and as the GNU GPL requires distribution of
 * source code.
 *
 * Note that people who make modified versions of this module
 * are not obligated to grant this special exception for their
 * modified versions; it is their choice whether to do so.  The GNU
 * General Public License gives permission to release a modified
 * version without this exception; this exception also makes it
 * possible to release a modified version which carries forward this
 * exception.
 *
 */

#ifndef lint
static const char rcsid[] =
    "@(#) $Header: /cvsroot/nsnam/ns-2/classifier/classifier-mpath.cc,v 1.10 2005/08/25 18:58:01 johnh Exp $ (USC/ISI)";
#endif

#include <string.h>
#include "tcl.h"
#include "node.h"
#include "scheduler.h"
#include "crc.h"
#include "classifier-mpath.h"

MultiPathForwarder::MultiPathForwarder() {
};

int MultiPathForwarder::classify(Packet* p) {
		int i;
		char hashStr[30];
		unsigned short hashVal;
		float ratio;
		int ret_slot;    // the slot number to be returned

		hdr_cmn* ch = HDR_CMN(p);
		hdr_ip* ip = hdr_ip::access(p);
		sprintf(hashStr,"%d %d %d %d", ip->saddr(), ip->sport(), ip->daddr(), ip->dport());

		hashVal = crcFast((unsigned char *)hashStr, strlen(hashStr));
        ratio = (float)hashVal / (0xFFFF + 1); 
		ret_slot = ratio * mynode->buckets;
		
		// check: to increase the number of ports
		if (mynode->dtq[ret_slot]->length() > mynode->high_length && mynode->buckets < mynode->k/2) {

			mynode->cal_energy();
		    mynode->port_state[mynode->k/2+mynode->buckets] = 2;  // become active
			mynode->active_num ++;

            Node * nh = Node::get_node_by_address(mynode->sw_nbr[mynode->buckets]);
		    nh->cal_energy();
			if (mynode->level == 1) {
    			nh->port_state[mynode->sw_index] = 2;
				if (nh->buckets == 0) {
				    nh->buckets = 1;
				}			   
			}
			else {
			    // level == 2
    			nh->port_state[mynode->pod] = 2;
			}
		    nh->active_num ++;
			
			mynode->buckets ++;
		}

		/*
		if (mynode->level == 1 && Agent::uidcnt_ > 1370000) {
		    printf("%f: occup %f hash %f buckets %d slot %d\n", Scheduler::instance().clock(), occp_sum, ratio, mynode->buckets, ret_slot);
		}
		*/
		return ret_slot;

};  // end of classify()

static class MultiPathClass : public TclClass {
public:
	MultiPathClass() : TclClass("Classifier/MultiPath") {} 
	TclObject* create(int, const char*const*) {
		return (new MultiPathForwarder());
	}
} class_multipath;
